# Continual Causal Representation Learning

## Description
This repository contains the code for the paper "Continual Causal Representation Learning" 

## Pre-requisites
You can use the following command to install the required packages:

> pip install -r requirements.txt

## Structure 
The structure of the code is as follows:

```
mycode/
|––README.md
|––requirements.txt
|––config/ 
|  |––test # the config file for train and test
|  |––data # the config file for generating data
|––data/ 
|  |––n_a_c_b_d_e_iid_f_trangle_g_mixed_h/
|  |  |––seed_k/
|  |  |  |––data
|  |  |  |––figure
|  |  |  |––model
|––synthetic/
|   |––components/
|   |––metrics/
|   |––...

```

## Reproduce the results
To reproduce the results, you can frist run the `large_dataset.ipynb` to create the dataset.

Then you can run the `main_moredomain.py` to train the model. 



